// ZSCPascalEditorDoc.cpp : implementation of the CZSCPascalEditorDoc class
//

#include "stdafx.h"
#include "resource.h"
#include "ZSCPascalEditorDoc.h"
#include "ZSCPascalEditorView.h"
#include "StringTokenizer.h"
#include "PascalAnalyzer.h"
#include "PascalCompiler.h"
#include "ResultDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CZSCPascalEditorDoc

IMPLEMENT_DYNCREATE(CZSCPascalEditorDoc, CDocument)

BEGIN_MESSAGE_MAP(CZSCPascalEditorDoc, CDocument)
	//{{AFX_MSG_MAP(CZSCPascalEditorDoc)
	ON_COMMAND(ID_SYNTAX, OnSyntax)
	ON_COMMAND(ID_ANALIZER_BUTTON, OnAnalizerButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CZSCPascalEditorDoc construction/destruction

CZSCPascalEditorDoc::CZSCPascalEditorDoc()
{
	// TODO: add one-time construction code here

}

CZSCPascalEditorDoc::~CZSCPascalEditorDoc()
{
}

BOOL CZSCPascalEditorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	((CZSCPascalEditorView*)m_viewList.GetHead())->SetWindowText(NULL);

	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CZSCPascalEditorDoc serialization

void CZSCPascalEditorDoc::Serialize(CArchive& ar)
{
	CZSCPascalEditorView* pView = (CZSCPascalEditorView*)m_viewList.GetHead();
	ASSERT_VALID(pView);
	ASSERT_KINDOF(CZSCPascalEditorView, pView);

	CRichEditCtrl& wndRich = pView->GetRichEditCtrl();
	CString str;

	//Write/Read raw data from file to/from RichEditControl
	if (ar.IsStoring())	{
		wndRich.GetWindowText(str);
		ar.Write((LPVOID)(LPCTSTR)str, str.GetLength()*sizeof(TCHAR));
	} else {
		CFile* pFile = ar.GetFile();
		ASSERT(pFile->GetPosition() == 0);
		DWORD nFileSize = pFile->GetLength();
		ar.Read((LPVOID)str.GetBuffer(nFileSize), nFileSize/sizeof(TCHAR));
		wndRich.SetWindowText(str);
	}

	ASSERT_VALID(this);
}

/////////////////////////////////////////////////////////////////////////////
// CZSCPascalEditorDoc diagnostics

#ifdef _DEBUG
void CZSCPascalEditorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CZSCPascalEditorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CZSCPascalEditorDoc commands

void CZSCPascalEditorDoc::OnSyntax() 
{
	// TODO: Add your command handler code here
	CZSCPascalEditorView* pView = (CZSCPascalEditorView*)m_viewList.GetHead();
	ASSERT_VALID(pView);
	ASSERT_KINDOF(CZSCPascalEditorView, pView);

	CRichEditCtrl& wndRich = pView->GetRichEditCtrl();
	CString str;
	wndRich.GetWindowText(str);
	CPascalCompiler *analizer = new CPascalCompiler(str);
	try
	{
		analizer->ProgramSursa ();
	}
	catch(error &e)
	{
		CString str = analizer->GetErrStr (e);
		AfxMessageBox(str);
		delete analizer;
		return;
	}
	delete analizer;
	AfxMessageBox("Evaluarea sintactica a avut success");
}

void CZSCPascalEditorDoc::OnAnalizerButton() 
{
	// TODO: Add your command handler code here
		// TODO: Add your command handler code here
	// Get Old Selection
	CZSCPascalEditorView* pView = (CZSCPascalEditorView*)m_viewList.GetHead();
	ASSERT_VALID(pView);
	ASSERT_KINDOF(CZSCPascalEditorView, pView);

	CRichEditCtrl& wndRich = pView->GetRichEditCtrl();
	CString str;
	wndRich.GetWindowText(str);
	CStringTokenizer *analizer = new CStringTokenizer(str);
	//analizer->PascalComments (FALSE);
	CResultDlg myDlg;
	myDlg.m_pAnalizer = analizer;
	myDlg.DoModal();
	delete analizer;
}
